The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Types | Public Member Functions | List of all members
stk::ADSR Class Reference

STK ADSR envelope class. More...

`#include <ADSR.h>`

Inheritance diagram for stk::ADSR:

## Public Types
enum | { ATTACK , DECAY , SUSTAIN , RELEASE , IDLE }
| ADSR envelope states. More...

## Public Member Functions
| ADSR (void)
| Default constructor.
| ~ADSR (void)
| Class destructor.
void | keyOn (void)
| Set target = 1, state = ADSR::ATTACK.
void | keyOff (void)
| Set target = 0, state = ADSR::RELEASE.
void | setAttackRate (StkFloat rate)
| Set the attack rate (gain / sample).
void | setAttackTarget (StkFloat target)
| Set the target value for the attack (default = 1.0).
void | setDecayRate (StkFloat rate)
| Set the decay rate (gain / sample).
void | setSustainLevel (StkFloat level)
| Set the sustain level.
void | setReleaseRate (StkFloat rate)
| Set the release rate (gain / sample).
void | setAttackTime (StkFloat time)
| Set the attack rate based on a time duration (seconds).
void | setDecayTime (StkFloat time)
| Set the decay rate based on a time duration (seconds).
void | setReleaseTime (StkFloat time)
| Set the release rate based on a time duration (seconds).
void | setAllTimes (StkFloat aTime, StkFloat dTime, StkFloat sLevel, StkFloat rTime)
| Set sustain level and attack, decay, and release time durations (seconds).
void | setTarget (StkFloat target)
| Set a sustain target value and attack or decay from current value to target.
int | getState (void) const
| Return the current envelope state (ATTACK, DECAY, SUSTAIN, RELEASE, IDLE).
void | setValue (StkFloat value)
| Set to state = ADSR::SUSTAIN with current and target values of value.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK ADSR envelope class.

This class implements a traditional ADSR (Attack, Decay, Sustain, Release) envelope. It responds to simple keyOn and keyOff messages, keeping track of its state. The state = ADSR::IDLE before being triggered and after the envelope value reaches 0.0 in the ADSR::RELEASE state. All rate, target and level settings must be non-negative. All time settings are in seconds and must be positive.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

ADSR envelope states.

Enumerator
ATTACK | Attack
DECAY | Decay
SUSTAIN | Sustain
RELEASE | Release
IDLE | Before attack / after release

29 {
30 ATTACK,
31 DECAY,
32 SUSTAIN,
33 RELEASE,
34 IDLE
35 };
stk::ADSR::SUSTAIN
@ SUSTAIN
Definition ADSR.h:32
stk::ADSR::IDLE
@ IDLE
Definition ADSR.h:34
stk::ADSR::DECAY
@ DECAY
Definition ADSR.h:31
stk::ADSR::RELEASE
@ RELEASE
Definition ADSR.h:33
stk::ADSR::ATTACK
@ ATTACK
Definition ADSR.h:30

## Member Function Documentation

## ◆ tick()

StkFrames & stk::ADSR::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

161{
162#if defined(_STK_DEBUG_)
163 if ( channel >= frames.channels() ) {
164 oStream_ << "ADSR::tick(): channel and StkFrames arguments are incompatible!";
165 handleError( StkError::FUNCTION_ARGUMENT );
166 }
167#endif
168
169 StkFloat *samples = &frames[channel];
170 unsigned int hop = frames.channels();
171 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
172 *samples = ADSR::tick();
173
174 return frames;
175}
stk::ADSR::tick
StkFloat tick(void)
Compute and return one output sample.
Definition ADSR.h:115
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- ADSR.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.